diff --git a/drupal7/sites/all/modules/date/date_all_day/date_all_day.info b/drupal7/sites/all/modules/date/date_all_day/date_all_day.info
index fcdc673a..f660d324 100644
--- a/drupal7/sites/all/modules/date/date_all_day/date_all_day.info
+++ b/drupal7/sites/all/modules/date/date_all_day/date_all_day.info
@@ -1,13 +1,17 @@
 name = Date All Day
 description = Adds 'All Day' functionality to date fields, including an 'All Day' theme and 'All Day' checkboxes for the Date select and Date popup widgets.
-dependencies[] = date_api
-dependencies[] = date
 package = Date/Time
 core = 7.x
 
-; Information added by Drupal.org packaging script on 2017-04-07
-version = "7.x-2.10"
+dependencies[] = date:date_api
+dependencies[] = date:date
+
+; Test coverage.
+files[] = tests/DateAllDayUiTestCase.test
+files[] = tests/DateAllDayUpdatesTest.test
+
+; Information added by Drupal.org packaging script on 2021-03-05
+version = "7.x-2.11"
 core = "7.x"
 project = "date"
-datestamp = "1491562090"
-
+datestamp = "1614952728"
diff --git a/drupal7/sites/all/modules/date/date_all_day/date_all_day.install b/drupal7/sites/all/modules/date/date_all_day/date_all_day.install
new file mode 100644
index 00000000..c5876f74
--- /dev/null
+++ b/drupal7/sites/all/modules/date/date_all_day/date_all_day.install
@@ -0,0 +1,113 @@
+<?php
+
+/**
+ * @file
+ * Update scripts for the Date All Day module.
+ */
+
+/**
+ * Change old "all day" values.
+ *
+ * Old data was stored with values with the time set to "00:00:00" whereas new
+ * data is stored with the time set to "23:59:59" (the minutes value varies
+ * depending upon the field's "increment" value), while keeping the same date.
+ *
+ * @todo Run this through a sandbox.
+ */
+function date_all_day_update_7200() {
+  // Get all fields provided by the Data module. This is used instead of the
+  // usual field_read_fields() because we want to select three different field
+  // types, whereas the API only supports one at a time.
+  $field_names = db_select('field_config', 'f')
+    ->fields('f', array('field_name'))
+    ->condition('f.type', array('datetime', 'date', 'datestamp'), 'IN')
+    ->execute()
+    ->fetchCol();
+
+  // Keep track of the fields that were processed.
+  $fields_processed = array();
+
+  // Loop over each of the fields that was found.
+  foreach ($field_names as $field_name) {
+    // Get the full specs of this base field.
+    $field = field_read_field($field_name);
+
+    // Loop over each instance of this field.
+    $params = array(
+      'field_name' => $field_name,
+    );
+    foreach (field_read_instances($params) as $instance) {
+      if (!empty($instance['widget']['settings']['display_all_day'])) {
+        $fields_processed[] = $field_name;
+
+        // If this field has a "to" date, the column to change is the "value2"
+        // column, otherwise just change the primary column.
+        if (!empty($field['settings']['todate'])) {
+          $field_to_change = $field_name . '_value2';
+        }
+        else {
+          $field_to_change = $field_name . '_value';
+        }
+
+        // Manually fix each record.
+        $records = db_select('field_data_' . $field_name, 'f')
+          ->fields('f')
+          ->condition('f.entity_type', $instance['entity_type'])
+          ->condition('f.bundle', $instance['bundle'])
+          ->condition('f.' . $field_to_change, '%:00:00', 'LIKE')
+          ->execute();
+
+        // The value that the widget is set to increment by. This is stored in
+        // minutes.
+        $increment = 1;
+        if (isset($instance['widget']['settings']['increment'])) {
+          $increment = $instance['widget']['settings']['increment'];
+        }
+
+        foreach ($records as $record) {
+          // Extract the value and convert it to a timestamp.
+          $end_date_value = $record->{$field_to_change};
+          $date = strtotime($end_date_value);
+
+          // The old time was stored with the value of midnight the day before
+          // the date that was intended, e.g. if the date was 2020-10-17 the
+          // time was stored as 0:00:00 thus the saved value "2020-10-17
+          // 00:00:00". This needs to be converted to 1 second before midnight
+          // on *that* day, i.e. "2020-10-17 23:59:59".
+          // @see hook_date_combo_validate_date_end_alter()
+          // @see date_all_day_date_combo_validate_date_start_alter()
+          $date += 23 * 60 * 60; // 23 hours.
+          $date += (60 - $increment) * 60; // 60 minutes - $increment, e.g. 59.
+          $date += 59; // 59 seconds.
+
+          // Reformat the date using an appropriate format for storing in the
+          // database.
+          $date = date(DATE_FORMAT_DATETIME, $date);
+
+          // Update the record.
+          db_update('field_data_' . $field_name)
+            ->fields(array(
+              $field_to_change => $date,
+            ))
+            ->condition('entity_type', $record->entity_type)
+            ->condition('bundle', $record->bundle)
+            ->condition('deleted', $record->deleted)
+            ->condition('revision_id', $record->revision_id)
+            ->condition('language', $record->language)
+            ->condition('delta', $record->delta)
+            ->execute();
+
+          // Clear the caches for this entity.
+          entity_get_controller($record->entity_type)->resetCache(array($record->entity_id));
+        }
+      }
+    }
+  }
+
+  // If any data was converted clear the site's caches.
+  if ($fields_processed) {
+    drupal_flush_all_caches();
+  }
+
+  return t('Processed %fields.', array('%fields' => implode(', ', $fields_processed)));
+}
diff --git a/drupal7/sites/all/modules/date/date_all_day/date_all_day.module b/drupal7/sites/all/modules/date/date_all_day/date_all_day.module
index e79bc944..fc775fc2 100644
--- a/drupal7/sites/all/modules/date/date_all_day/date_all_day.module
+++ b/drupal7/sites/all/modules/date/date_all_day/date_all_day.module
@@ -4,16 +4,15 @@
  * @file
  * Adds All Day functionality to the Date field.
  *
- * This module implements a number of hooks in the Date field and
- * Date api element processing and to add an All Day checkbox to
- * date widgets, and also adds an All Day theme and
- * All Day information to the formatting.
+ * This module implements a number of hooks in the Date field and Date API
+ * element processing and to add an All Day checkbox to date widgets, and also
+ * adds an All Day theme and All Day information to the formatting.
  *
- * Keep in mind that the process hooks are fired from the top down,
- * first date_combo, then the date_select or date_popup.
+ * Keep in mind that the process hooks are fired from the top down, first
+ * date_combo, then the date_select or date_popup.
  *
- * Validation fires from the bottom up, first date_select and
- * date_popup, then date_combo.
+ * Validation fires from the bottom up, first date_select and date_popup, then
+ * date_combo.
  */
 
 /**
@@ -44,12 +43,9 @@ function date_all_day_theme() {
 
 /**
  * Implements hook_date_formatter_dates_alter().
- *
- * This allows us to alter the $dates array created
- * by date_formatter_process.
  */
 function date_all_day_date_formatter_dates_alter(&$dates, $context) {
-
+  // This allows us to alter the $dates array created by date_formatter_process.
   $field = $context['field'];
   $instance = $context['instance'];
   $format = $context['format'];
@@ -57,7 +53,6 @@ function date_all_day_date_formatter_dates_alter(&$dates, $context) {
   $entity = $context['entity'];
   $date1 = $dates['value']['local']['object'];
   $date2 = $dates['value2']['local']['object'];
-
   $is_all_day = date_all_day_field($field, $instance, $date1, $date2);
 
   $all_day1 = '';
@@ -71,7 +66,8 @@ function date_all_day_date_formatter_dates_alter(&$dates, $context) {
       'date2' => $date2,
       'format' => $format,
       'entity_type' => $entity_type,
-      'entity' => $entity));
+      'entity' => $entity,
+    ));
     $all_day2 = theme('date_all_day', array(
       'field' => $field,
       'instance' => $instance,
@@ -80,7 +76,8 @@ function date_all_day_date_formatter_dates_alter(&$dates, $context) {
       'date2' => $date2,
       'format' => $format,
       'entity_type' => $entity_type,
-      'entity' => $entity));
+      'entity' => $entity,
+    ));
     $dates['value']['formatted_time'] = theme('date_all_day_label');
     $dates['value2']['formatted_time'] = theme('date_all_day_label');
     $dates['value']['formatted'] = $all_day1;
@@ -91,39 +88,33 @@ function date_all_day_date_formatter_dates_alter(&$dates, $context) {
 /**
  * Adjust start/end date format to account for 'all day' .
  *
- * @params array $field
+ * @param array $field
  *   The field definition for this date field.
- *
- * @params string $which
+ * @param string $which
  *   Which value to return, 'date1' or 'date2'.
- *
- * @params object $date1
+ * @param object $date1
  *   A date/time object for the 'start' date.
- *
- * @params object $date2
+ * @param object $date2
  *   A date/time object for the 'end' date.
- *
- * @params string $format
- *   A date/time format
- *
- * @params object $entity
+ * @param string $format
+ *   A date/time format.
+ * @param object $entity
  *   The node this date comes from (may be incomplete, always contains nid).
- *
- * @params object $view
+ * @param object $view
  *   The view this node comes from, if applicable.
  *
- * @return string
+ * @return string|null
  *   Formatted date.
  */
 function theme_date_all_day($vars) {
-  $field    = $vars['field'];
+  $field = $vars['field'];
   $instance = $vars['instance'];
-  $which    = $vars['which'];
-  $date1    = $vars['date1'];
-  $date2    = $vars['date2'];
-  $format   = $vars['format'];
-  $entity   = $vars['entity'];
-  $view     = !empty($vars['view']) ? $vars['view'] : NULL;
+  $which = $vars['which'];
+  $date1 = $vars['date1'];
+  $date2 = $vars['date2'];
+  $format = $vars['format'];
+  $entity = $vars['entity'];
+  $view = !empty($vars['view']) ? $vars['view'] : NULL;
 
   if (empty($date1) || !is_object($date1) || $format == 'format_interval') {
     return;
@@ -156,7 +147,7 @@ function theme_date_all_day($vars) {
  * Theme the way an 'all day' label will look.
  */
 function theme_date_all_day_label() {
-  return '(' . t('All day', array(), array('context' => 'datetime')) . ')';
+  return t('(All day)', array(), array('context' => 'datetime'));
 }
 
 /**
@@ -164,42 +155,61 @@ function theme_date_all_day_label() {
  *
  * @param array $field
  *   The field definition for this date field.
- *
  * @param array $instance
  *   The field instance for this date field.
- *
  * @param object $date1
  *   A date/time object for the 'Start' date.
- *
  * @param object $date2
  *   A date/time object for the 'End' date.
  *
  * @return bool
  *   TRUE or FALSE.
  */
-function date_all_day_field($field, $instance, $date1, $date2 = NULL) {
+function date_all_day_field(array $field, array $instance, $date1, $date2 = NULL) {
   if (empty($date1) || !is_object($date1)) {
     return FALSE;
   }
   elseif (!date_has_time($field['settings']['granularity'])) {
-    return TRUE;
+    return FALSE;
+  }
+  // The master setting for the 'all day' functionality.
+  elseif (empty($instance['widget']['settings']['display_all_day'])) {
+    return FALSE;
   }
+
   if (empty($date2)) {
     $date2 = $date1;
   }
 
+  // Several scenarios result in the two date values being the same, e.g.
+  // date_formatter_process().
+  if ($date1 == $date2) {
+    // Clone the date object so that changes made to the object won't affect
+    // both variables.
+    $date1 = clone $date2;
+
+    // Set the time to midnight so that the two variables can be properly
+    // compared later in date_is_all_day().
+    $date1->setTime(0, 0, 0);
+  }
+
+  // Use central logic for determining the granularity.
   $granularity = date_granularity_precision($field['settings']['granularity']);
-  $increment = isset($instance['widget']['settings']['increment']) ? $instance['widget']['settings']['increment'] : 1;
+
+  // The increment is 1 by default, but it can be overridden.
+  $increment = 1;
+  if (isset($instance['widget']['settings']['increment'])) {
+    $increment = $instance['widget']['settings']['increment'];
+  }
+
   return date_is_all_day(date_format($date1, DATE_FORMAT_DATETIME), date_format($date2, DATE_FORMAT_DATETIME), $granularity, $increment);
 }
 
 /**
  * Implements hook_date_combo_process_alter().
- *
- * This hook lets us make changes to the date_combo element.
  */
 function date_all_day_date_combo_process_alter(&$element, &$form_state, $context) {
-
+  // This hook lets us make changes to the date_combo element.
   $field = $context['field'];
   $instance = $context['instance'];
 
@@ -211,13 +221,15 @@ function date_all_day_date_combo_process_alter(&$element, &$form_state, $context
     $all_day_id = $first_parent . '[' . implode('][', $parents) . '][all_day]';;
     foreach (array('value', 'value2') as $key) {
       if (array_key_exists($key, $element)) {
-        $element[$key]['#date_all_day_id']  = $all_day_id;
+        $element[$key]['#date_all_day_id'] = $all_day_id;
       }
     }
 
     $from = $element['#default_value']['value'];
     $to = !empty($element['#default_value']['value2']) ? $element['#default_value']['value2'] : $element['#default_value']['value'];
-    $date_is_all_day = date_is_all_day($from, $to);
+    $granularity = date_granularity_precision($context['field']['settings']['granularity']);
+    $increment = isset($context['instance']['widget']['settings']['increment']) ? $context['instance']['widget']['settings']['increment'] : 1;
+    $date_is_all_day = date_is_all_day($from, $to, $granularity, $increment);
     $all_day = !empty($form_state['values']['all_day']) || $date_is_all_day;
     $element['all_day'] = array(
       '#title' => t('All Day'),
@@ -236,30 +248,24 @@ function date_all_day_date_combo_process_alter(&$element, &$form_state, $context
   }
 }
 
-
 /**
  * Implements hook_date_text_process_alter().
- *
- * This hook lets us make changes to the date_select widget.
  */
 function date_all_day_date_text_process_alter(&$element, &$form_state, $context) {
+  // This hook lets us make changes to the date_select widget.
   $all_day_id = !empty($element['#date_all_day_id']) ? $element['#date_all_day_id'] : '';
   if ($all_day_id != '') {
-    // All Day handling on text dates works only
-    // if the user leaves the time out of the input value.
-    // There is no element to hide or show.
+    // All Day handling on text dates works only if the user leaves the time
+    // out of the input value. There is no element to hide or show.
   }
 }
 
 /**
  * Implements hook_date_select_process_alter().
- *
- * This hook lets us make changes to the date_select widget.
  */
 function date_all_day_date_select_process_alter(&$element, &$form_state, $context) {
-
-  // Hide or show this element in reaction
-  // to the all_day status for this element.
+  // This hook lets us make changes to the date_select widget. Hide or show
+  // this element in reaction to the all_day status for this element.
   $all_day_id = !empty($element['#date_all_day_id']) ? $element['#date_all_day_id'] : '';
   if ($all_day_id != '') {
     foreach (array('hour', 'minute', 'second', 'ampm') as $field) {
@@ -267,7 +273,8 @@ function date_all_day_date_select_process_alter(&$element, &$form_state, $contex
         $element[$field]['#states'] = array(
           'visible' => array(
             'input[name="' . $all_day_id . '"]' => array('checked' => FALSE),
-          ));
+          ),
+        );
       }
     }
   }
@@ -275,69 +282,60 @@ function date_all_day_date_select_process_alter(&$element, &$form_state, $contex
 
 /**
  * Implements hook_date_popup_process_alter().
- *
- * This hook lets us make changes to the date_popup element.
  */
 function date_all_day_date_popup_process_alter(&$element, &$form_state, $context) {
-
-  // Hide or show this element in reaction to
-  // the all_day status for this element.
+  // This hook lets us make changes to the date_popup element. Hide or show
+  // this element in reaction to the all_day status for this element.
   $all_day_id = !empty($element['#date_all_day_id']) ? $element['#date_all_day_id'] : '';
   if ($all_day_id != '' && array_key_exists('time', $element)) {
     $element['time']['#states'] = array(
       'visible' => array(
         'input[name="' . $all_day_id . '"]' => array('checked' => FALSE),
-      ));
+      ),
+    );
   }
 }
 
 /**
  * Implements hook_date_select_pre_validate_alter().
- *
- * This hook lets us alter the element or the form_state before the rest
- * of the date_select validation gets fired.
  */
 function date_all_day_date_text_pre_validate_alter(&$element, &$form_state, &$input) {
-  // Let Date module massage the format for all day
-  // values so they will pass validation.
-  // The All day flag, if used, actually exists on the parent element.
+  // This hook lets us alter the element or the form_state before the rest of
+  // the date_select validation gets fired. Let Date module massage the format
+  // for all day values so they will pass validation. The All day flag, if
+  // used, actually exists on the parent element.
   date_all_day_value($element, $form_state);
 }
 
 /**
  * Implements hook_date_select_pre_validate_alter().
- *
- * This hook lets us alter the element or the form_state before the rest
- * of the date_select validation gets fired.
  */
 function date_all_day_date_select_pre_validate_alter(&$element, &$form_state, &$input) {
-  // Let Date module massage the format for all
-  // day values so they will pass validation.
-  // The All day flag, if used, actually exists on the parent element.
+  // This hook lets us alter the element or the form_state before the rest of
+  // the date_select validation gets fired. Let Date module massage the format
+  // for all day values so they will pass validation. The All day flag, if
+  // used, actually exists on the parent element.
   date_all_day_value($element, $form_state);
 }
 
 /**
  * Implements hook_date_select_pre_validate_alter().
- *
- * This hook lets us alter the element or the form_state before the rest
- * of the date_popup validation gets fired.
  */
 function date_all_day_date_popup_pre_validate_alter(&$element, &$form_state, &$input) {
-  // Let Date module massage the format for all
-  // day values so they will pass validation.
-  // The All day flag, if used, actually exists on the parent element.
+  // This hook lets us alter the element or the form_state before the rest of
+  // the date_popup validation gets fired. Let Date module massage the format
+  // for all day values so they will pass validation. The All day flag, if
+  // used, actually exists on the parent element.
   date_all_day_value($element, $form_state);
 }
 
 /**
  * A helper function date_all_day_value().
- *
- * To check if the all day flag is set on the parent of an
- * element, and adjust the date_format accordingly so the missing time will
- * not cause validation errors.
  */
 function date_all_day_value(&$element, $form_state) {
+  // To check if the all day flag is set on the parent of an element, and
+  // adjust the date_format accordingly so the missing time will not cause
+  // validation errors.
   if (!empty($element['#date_all_day_id'])) {
     $parents = $element['#parents'];
     array_pop($parents);
@@ -352,14 +350,11 @@ function date_all_day_value(&$element, $form_state) {
 
 /**
  * Implements hook_date_combo_pre_validate_alter().
- *
- * This hook lets us alter the element or the form_state before the rest
- * of the date_combo validation gets fired.
  */
 function date_all_day_date_combo_pre_validate_alter(&$element, &$form_state, $context) {
-
+  // This hook lets us alter the element or the form_state before the rest of
+  // the date_combo validation gets fired.
   if (!empty($context['item']['all_day'])) {
-
     $field = $context['field'];
 
     // If we have an all day flag on this date and the time is empty,
@@ -375,13 +370,11 @@ function date_all_day_date_combo_pre_validate_alter(&$element, &$form_state, $co
 
 /**
  * Implements hook_date_combo_validate_date_start_alter().
- *
- * This hook lets us alter the local date objects
- * created by the date_combo validation before they are
- * converted back to the database timezone and stored.
  */
 function date_all_day_date_combo_validate_date_start_alter(&$date, &$form_state, $context) {
-  // If this is an 'All day' value, set the time to midnight.
+  // This hook lets us alter the local date objects created by the date_combo
+  // validation before they are converted back to the database timezone and
+  // stored. If this is an 'All day' value, set the time to midnight.
   if (!empty($context['element']['#date_is_all_day'])) {
     $date->setTime(0, 0, 0);
   }
@@ -389,24 +382,26 @@ function date_all_day_date_combo_validate_date_start_alter(&$date, &$form_state,
 
 /**
  * Implements hook_date_combo_validate_date_end_alter().
- *
- * This hook lets us alter the local date objects
- * created by the date_combo validation before
- * they are converted back to the database timezone and stored.
  */
 function date_all_day_date_combo_validate_date_end_alter(&$date, &$form_state, $context) {
-  // If this is an 'All day' value, set the time to midnight.
+  // This hook lets us alter the local date objects created by the date_combo
+  // validation before they are converted back to the database timezone and
+  // stored. If this is an 'All day' value, set the time as close to midnight as
+  // possible.
   if (!empty($context['element']['#date_is_all_day'])) {
-    $date->setTime(0, 0, 0);
+    $increment = isset($context['instance']['widget']['settings']['increment']) ? $context['instance']['widget']['settings']['increment'] : 1;
+    // @todo Should this reduce by an additional 1 minute if the increment is
+    // more than 1? For example, if the increment is 15 should the upper value
+    // be 23:45:59 or 23:44:59?
+    $date->setTime(23, 60 - $increment, 59);
   }
 }
 
 /**
  * Implements hook_field_widget_info_alter().
- *
- * This Field API hook lets us add a new setting to the widgets.
  */
 function date_all_day_field_widget_info_alter(&$info) {
+  // This Field API hook lets us add a new setting to the widgets.
   // Add a setting to a widget type.
   $info['date_select']['settings'] += array(
     'display_all_day' => 0,
@@ -423,12 +418,10 @@ function date_all_day_field_widget_info_alter(&$info) {
 
 /**
  * Implements hook_date_field_widget_settings_form_alter().
- *
- * This hook lets us alter the field settings form by adding a place
- * to set the value added above.
  */
 function date_all_day_date_field_widget_settings_form_alter(&$form, $context) {
-
+  // This hook lets us alter the field settings form by adding a place to set
+  // the value added above.
   $field = $context['field'];
   $instance = $context['instance'];
 
diff --git a/drupal7/sites/all/modules/date/date_all_day/tests/DateAllDayUiTestCase.test b/drupal7/sites/all/modules/date/date_all_day/tests/DateAllDayUiTestCase.test
new file mode 100644
index 00000000..708112c2
--- /dev/null
+++ b/drupal7/sites/all/modules/date/date_all_day/tests/DateAllDayUiTestCase.test
@@ -0,0 +1,104 @@
+<?php
+
+/**
+ * @file
+ * Test Date All Day functionality.
+ */
+
+/**
+ * Test Date All Day functionality.
+ */
+class DateAllDayUiTestCase extends DateFieldTestBase {
+
+  /**
+   *
+   */
+  public static function getInfo() {
+    return array(
+      'name' => t('Date All Day unit'),
+      'description' => t('Test Date All Day functions.') ,
+      'group' => t('Date'),
+    );
+  }
+
+  /**
+   * {@inheritdoc}
+   */
+  public function setUp(array $modules = array()) {
+    $modules[] = 'date_all_day';
+    $modules[] = 'date_all_day_test_feature';
+    parent::setUp($modules);
+
+    // Provide a date format that includes the main values.
+    variable_set('date_format_long', 'D, m/d/Y - H:i');
+
+    // Turn off the option to let users change their timezone, so that all date
+    // values will have a fixed output.
+    variable_set('configurable_timezones', FALSE);
+  }
+
+  /**
+   * Test the node form, confirm the "Date all day" field exists & works.
+   */
+  public function testAllDayField() {
+    // A first node, with the "all day" option disabled.
+    $this->drupalGet('node/add/date-all-day-test');
+    $this->assertResponse(200);
+
+    // Confirm the 'date all day' field exists.
+    $this->assertFieldByName('field_date_all_day[und][0][all_day]');
+    $this->assertFieldByName('field_date_all_day[und][0][value][month]');
+    $this->assertFieldByName('field_date_all_day[und][0][value][day]');
+    $this->assertFieldByName('field_date_all_day[und][0][value][year]');
+    $this->assertFieldByName('field_date_all_day[und][0][value][hour]');
+    $this->assertFieldByName('field_date_all_day[und][0][value][minute]');
+
+    // Submit the node form.
+    $edit = array(
+      'title' => 'Testing the All Day option',
+      'field_date_all_day[und][0][all_day]' => FALSE,
+      'field_date_all_day[und][0][value][month]' => 2,
+      'field_date_all_day[und][0][value][day]' => 11,
+      'field_date_all_day[und][0][value][year]' => 2021,
+      'field_date_all_day[und][0][value][hour]' => 18,
+      'field_date_all_day[und][0][value][minute]' => 15,
+    );
+    $this->drupalPost(NULL, $edit, 'Save');
+    $this->assertResponse(200);
+
+    // Confirm the data is displayed correctly.
+    $this->assertText('Testing the All Day option');
+    $this->assertText('Date All Day');
+    $this->assertText('Thu, 02/11/2021 - 18:15');
+
+    // A second node, this time with the "all day" option enabled.
+    $this->drupalGet('node/add/date-all-day-test');
+    $this->assertResponse(200);
+
+    // Submit the node form.
+    $edit = array(
+      'title' => 'Testing the All Day option again',
+      'field_date_all_day[und][0][all_day]' => TRUE,
+      'field_date_all_day[und][0][value][month]' => 2,
+      'field_date_all_day[und][0][value][day]' => 11,
+      'field_date_all_day[und][0][value][year]' => 2021,
+      'field_date_all_day[und][0][value][hour]' => 18,
+      'field_date_all_day[und][0][value][minute]' => 15,
+    );
+    $this->drupalPost(NULL, $edit, 'Save');
+    $this->assertResponse(200);
+
+    // Confirm the data is displayed correctly.
+    $this->assertText('Testing the All Day option again');
+    $this->assertText('Date All Day');
+    $this->assertText('Thu, 02/11/2021 (All day)');
+
+    // Load the node and confirm the data is as expected.
+    $node = node_load(2);
+    $this->verbose($node);
+    $this->assertEqual($node->title, $edit['title']);
+    $this->assertTrue(isset($node->field_date_all_day[LANGUAGE_NONE][0]['value']));
+    $this->assertEqual($node->field_date_all_day[LANGUAGE_NONE][0]['value'], '2021-02-11 23:45:59');
+  }
+
+}
diff --git a/drupal7/sites/all/modules/date/date_all_day/tests/DateAllDayUpdatesTest.test b/drupal7/sites/all/modules/date/date_all_day/tests/DateAllDayUpdatesTest.test
new file mode 100644
index 00000000..6c54eab8
--- /dev/null
+++ b/drupal7/sites/all/modules/date/date_all_day/tests/DateAllDayUpdatesTest.test
@@ -0,0 +1,151 @@
+<?php
+
+/**
+ * @file
+ * Test updates for the Date All Day module.
+ */
+
+/**
+ * Test updates for the Date All Day module.
+ */
+class DateAllDayUpdatesTest extends DrupalWebTestCase {
+
+  /**
+   * Define this test class.
+   */
+  public static function getInfo() {
+    return array(
+      'name' => t('Update updates'),
+      'description' => t('Confirm update Date All Day updates works as intended.'),
+      'group' => t('Date'),
+    );
+  }
+
+  /**
+   * {@inheritdoc}
+   */
+  public function setUp(array $modules = array()) {
+    $modules[] = 'date_all_day_test_feature';
+    parent::setUp($modules);
+
+    // Error logging.
+    variable_set('error_level', 2);
+
+    // Log in as user 1, so that permissions are irrelevant.
+    $this->loginUser1();
+
+    // Clear the caches so that the field specs are properly loaded.
+    cache_clear_all();
+  }
+
+  /**
+   * Log in as user 1.
+   *
+   * The benefit of doing this is that it ignores permissions entirely, so the
+   * raw functionality can be tested.
+   */
+  protected function loginUser1() {
+    // Load user 1.
+    $account = user_load(1, TRUE);
+
+    // Reset the password.
+    $password = user_password();
+    $edit = array(
+      'pass' => $password,
+    );
+    user_save($account, $edit);
+    $account->pass_raw = $password;
+
+    // Login.
+    $this->drupalLogin($account);
+  }
+
+  /**
+   * {@inheritdoc}
+   */
+  protected function verbose($message, $title = NULL) {
+    // Handle arrays, objects, etc.
+    if (!is_string($message)) {
+      $message = "<pre>\n" . print_r($message, TRUE) . "\n</pre>\n";
+    }
+
+    // Optional title to go before the output.
+    if (!empty($title)) {
+      $title = '<h2>' . check_plain($title) . "</h2>\n";
+    }
+
+    parent::verbose($title . $message);
+  }
+
+  /**
+   * Test update 7200.
+   */
+  public function testUpdate7200() {
+    // Load the install file, so that the update script is available.
+    module_load_include('install', 'date_all_day');
+    $this->assertEqual(function_exists('date_all_day_update_7200'), TRUE, 'Update 7200 exists.');
+
+    // Create a sample node.
+    $this->drupalGet('node/add/date-all-day-test');
+    $this->assertResponse(200);
+    $this->assertText('Create Date Test');
+
+    $edit = array(
+      'title' => 'Test All Day option',
+      // This field is required.
+      // 'field_datetime_range[und][0][value2][date]' => '2020-09-07 08:00:00',
+      // The All-Day field.
+      'field_date_all_day[und][0][all_day]' => TRUE,
+      'field_date_all_day[und][0][value][year]' => 2020,
+      'field_date_all_day[und][0][value][month]' => 8,
+      'field_date_all_day[und][0][value][day]' => 30,
+    );
+    $this->drupalPost(NULL, $edit, 'Save');
+    $this->assertResponse(200);
+    // Make sure the form submitted.
+    $this->assertNoText('Create Date Test');
+
+    // Load the node.
+    // @todo get the node ID from the URL.
+    $node = node_load(1, NULL, TRUE);
+    $this->verbose($node);
+
+    // Update the field so it's stored the old way.
+    $node->field_date_all_day[LANGUAGE_NONE][0]['value'] = '2020-08-30 00:00:00';
+    node_save($node);
+
+    // Reload the node and confirm that it has the old value stored.
+    $node = node_load($node->nid, NULL, TRUE);
+    $this->verbose($node);
+    $this->assertEqual($node->field_date_all_day[LANGUAGE_NONE][0]['value'], '2020-08-30 00:00:00');
+
+    // Load the code, confirm the data is invalid.
+    $this->drupalGet('node/' . $node->nid);
+    $this->assertResponse(200);
+    $this->assertText($edit['title']);
+    $this->assertText('Date All Day');
+    $this->assertNoText('Sunday, August 30, 2020 (All day)');
+
+    // Load the node's edit form to confirm the values are incorrect.
+    $this->drupalGet('node/' . $node->nid . '/edit');
+    $this->assertResponse(200);
+
+    // Execute the update function.
+    $results = date_all_day_update_7200();
+    $this->assertTrue($results);
+    $this->verbose($results);
+
+    // Reload the node and confirm that it has the old value stored.
+    $node = node_load($node->nid, NULL, TRUE);
+    $this->verbose($node);
+    // The expected timestamp is relative to the increment value, which is set
+    // to 15 minutes for this field.
+    $this->assertEqual($node->field_date_all_day[LANGUAGE_NONE][0]['value'], '2020-08-30 23:45:59');
+
+    // Load the node again, confirm the data is now valid.
+    $this->drupalGet('node/' . $node->nid);
+    $this->assertText('Date All Day:');
+    $this->assertText('Sunday, August 30, 2020 (All day)');
+  }
+
+}
